/* A Bison parser, made by GNU Bison 3.6.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.6.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         phpparse
#define yylex           phplex
#define yyerror         phperror
#define yydebug         phpdebug
#define yynerrs         phpnerrs
#define yylval          phplval
#define yychar          phpchar

/* First part of user prologue.  */
#line 1 "php_parser.y"

//
// This file is part of the aMule Project.
//
// Copyright (c) 2003-2011 aMule Team ( admin@amule.org / http://www.amule.org )
// Copyright (c) 2005-2011 Froenchenko Leonid ( lfroen@gmail.com / http://www.amule.org )
//
// Any parts of this program derived from the xMule, lMule or eMule project,
// or contributed by third-party developers are copyrighted by their
// respective authors.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA
//

#include <stdio.h>
#include <string.h>

#include "php_syntree.h"

int phplex();

// add item to syntree list
PHP_SYN_NODE *add_statement_2_list(PHP_SYN_NODE *list, PHP_SYN_NODE *st)
{
	if ( st && list) {
		PHP_SYN_NODE *last = list;
		while ( last->next_node ) {
			last = last->next_node;
		}
		last->next_node = st;
		return list;
	} else if ( st ) {
		return st;
	} else {
		return list;
	}
}

PHP_SYN_NODE *add_branch_2_elseif(PHP_SYN_NODE *list, PHP_SYN_NODE *branch)
{
	if ( list ) {
		PHP_SYN_NODE *curr_if = list;
		while ( curr_if->node_if.code_else ) {
			curr_if = curr_if->node_if.code_else;
		}
		curr_if->node_if.code_else = branch;
		return list;
	} else {
		return branch;
	}
}


#line 144 "php_parser.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_PHP_PHP_PARSER_H_INCLUDED
# define YY_PHP_PHP_PARSER_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int phpdebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    FNUMBER = 258,                 /* FNUMBER  */
    DNUMBER = 259,                 /* DNUMBER  */
    STRING = 260,                  /* STRING  */
    IDENT = 261,                   /* IDENT  */
    VARIABLE = 262,                /* VARIABLE  */
    T_ECHO = 263,                  /* T_ECHO  */
    EXIT = 264,                    /* EXIT  */
    IF = 265,                      /* IF  */
    DO = 266,                      /* DO  */
    WHILE = 267,                   /* WHILE  */
    ENDWHILE = 268,                /* ENDWHILE  */
    FOR = 269,                     /* FOR  */
    ENDFOR = 270,                  /* ENDFOR  */
    FOREACH = 271,                 /* FOREACH  */
    ENDFOREACH = 272,              /* ENDFOREACH  */
    DECLARE = 273,                 /* DECLARE  */
    ENDDECLARE = 274,              /* ENDDECLARE  */
    AS = 275,                      /* AS  */
    CONST = 276,                   /* CONST  */
    GLOBAL = 277,                  /* GLOBAL  */
    UNSET = 278,                   /* UNSET  */
    ISSET = 279,                   /* ISSET  */
    EMPTY = 280,                   /* EMPTY  */
    SWITCH = 281,                  /* SWITCH  */
    ENDSWITCH = 282,               /* ENDSWITCH  */
    CASE = 283,                    /* CASE  */
    DEFAULT = 284,                 /* DEFAULT  */
    BREAK = 285,                   /* BREAK  */
    CONTINUE = 286,                /* CONTINUE  */
    FUNCTION = 287,                /* FUNCTION  */
    RETURN = 288,                  /* RETURN  */
    CLASS = 289,                   /* CLASS  */
    INTERFACE = 290,               /* INTERFACE  */
    EXTENDS = 291,                 /* EXTENDS  */
    IMPLEMENTS = 292,              /* IMPLEMENTS  */
    OBJECT_OPERATOR = 293,         /* OBJECT_OPERATOR  */
    HASH_ASSIGN = 294,             /* HASH_ASSIGN  */
    LIST = 295,                    /* LIST  */
    ARRAY = 296,                   /* ARRAY  */
    CLASS_SCOPE = 297,             /* CLASS_SCOPE  */
    PRINT = 298,                   /* PRINT  */
    PLUS_EQ = 299,                 /* PLUS_EQ  */
    MINUS_EQ = 300,                /* MINUS_EQ  */
    MUL_EQ = 301,                  /* MUL_EQ  */
    DIV_EQ = 302,                  /* DIV_EQ  */
    CONCAT_EQ = 303,               /* CONCAT_EQ  */
    MOD_EQ = 304,                  /* MOD_EQ  */
    AND_EQ = 305,                  /* AND_EQ  */
    OR_EQ = 306,                   /* OR_EQ  */
    XOR_EQ = 307,                  /* XOR_EQ  */
    SL_EQ = 308,                   /* SL_EQ  */
    SR_EQ = 309,                   /* SR_EQ  */
    LOG_OR = 310,                  /* LOG_OR  */
    LOG_XOR = 311,                 /* LOG_XOR  */
    LOG_AND = 312,                 /* LOG_AND  */
    BOOLEAN_OR = 313,              /* BOOLEAN_OR  */
    BOOLEAN_AND = 314,             /* BOOLEAN_AND  */
    IS_EQ = 315,                   /* IS_EQ  */
    IS_NOEQUAL = 316,              /* IS_NOEQUAL  */
    IS_IDENTICAL = 317,            /* IS_IDENTICAL  */
    IS_NOIDENTICAL = 318,          /* IS_NOIDENTICAL  */
    IS_SMALLER_OR_EQ = 319,        /* IS_SMALLER_OR_EQ  */
    IS_GREATER_OR_EQ = 320,        /* IS_GREATER_OR_EQ  */
    SL = 321,                      /* SL  */
    SR = 322,                      /* SR  */
    INSTANCEOF = 323,              /* INSTANCEOF  */
    INC = 324,                     /* INC  */
    DEC = 325,                     /* DEC  */
    INT_CAST = 326,                /* INT_CAST  */
    DOUBLE_CAST = 327,             /* DOUBLE_CAST  */
    STRING_CAST = 328,             /* STRING_CAST  */
    ARRAY_CAST = 329,              /* ARRAY_CAST  */
    OBJECT_CAST = 330,             /* OBJECT_CAST  */
    BOOL_CAST = 331,               /* BOOL_CAST  */
    UNSET_CAST = 332,              /* UNSET_CAST  */
    NEW = 333,                     /* NEW  */
    CLONE = 334,                   /* CLONE  */
    ELSEIF = 335,                  /* ELSEIF  */
    ELSE = 336,                    /* ELSE  */
    ENDIF = 337,                   /* ENDIF  */
    STATIC = 338,                  /* STATIC  */
    ABSTRACT = 339,                /* ABSTRACT  */
    FINAL = 340,                   /* FINAL  */
    PRIVATE = 341,                 /* PRIVATE  */
    PROTECTED = 342,               /* PROTECTED  */
    PUBLIC = 343,                  /* PUBLIC  */
    START_SCRIPT = 344,            /* START_SCRIPT  */
    END_SCRIPT = 345               /* END_SCRIPT  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 67 "php_parser.y"

	PHP_SYN_NODE *syn_node;
	PHP_EXP_NODE *exp_node;

	char str_val[256];

#line 291 "php_parser.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE phplval;

int phpparse (void);

#endif /* !YY_PHP_PHP_PARSER_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_FNUMBER = 3,                    /* FNUMBER  */
  YYSYMBOL_DNUMBER = 4,                    /* DNUMBER  */
  YYSYMBOL_STRING = 5,                     /* STRING  */
  YYSYMBOL_IDENT = 6,                      /* IDENT  */
  YYSYMBOL_VARIABLE = 7,                   /* VARIABLE  */
  YYSYMBOL_T_ECHO = 8,                     /* T_ECHO  */
  YYSYMBOL_EXIT = 9,                       /* EXIT  */
  YYSYMBOL_IF = 10,                        /* IF  */
  YYSYMBOL_DO = 11,                        /* DO  */
  YYSYMBOL_WHILE = 12,                     /* WHILE  */
  YYSYMBOL_ENDWHILE = 13,                  /* ENDWHILE  */
  YYSYMBOL_FOR = 14,                       /* FOR  */
  YYSYMBOL_ENDFOR = 15,                    /* ENDFOR  */
  YYSYMBOL_FOREACH = 16,                   /* FOREACH  */
  YYSYMBOL_ENDFOREACH = 17,                /* ENDFOREACH  */
  YYSYMBOL_DECLARE = 18,                   /* DECLARE  */
  YYSYMBOL_ENDDECLARE = 19,                /* ENDDECLARE  */
  YYSYMBOL_AS = 20,                        /* AS  */
  YYSYMBOL_CONST = 21,                     /* CONST  */
  YYSYMBOL_GLOBAL = 22,                    /* GLOBAL  */
  YYSYMBOL_UNSET = 23,                     /* UNSET  */
  YYSYMBOL_ISSET = 24,                     /* ISSET  */
  YYSYMBOL_EMPTY = 25,                     /* EMPTY  */
  YYSYMBOL_SWITCH = 26,                    /* SWITCH  */
  YYSYMBOL_ENDSWITCH = 27,                 /* ENDSWITCH  */
  YYSYMBOL_CASE = 28,                      /* CASE  */
  YYSYMBOL_DEFAULT = 29,                   /* DEFAULT  */
  YYSYMBOL_BREAK = 30,                     /* BREAK  */
  YYSYMBOL_CONTINUE = 31,                  /* CONTINUE  */
  YYSYMBOL_FUNCTION = 32,                  /* FUNCTION  */
  YYSYMBOL_RETURN = 33,                    /* RETURN  */
  YYSYMBOL_CLASS = 34,                     /* CLASS  */
  YYSYMBOL_INTERFACE = 35,                 /* INTERFACE  */
  YYSYMBOL_EXTENDS = 36,                   /* EXTENDS  */
  YYSYMBOL_IMPLEMENTS = 37,                /* IMPLEMENTS  */
  YYSYMBOL_OBJECT_OPERATOR = 38,           /* OBJECT_OPERATOR  */
  YYSYMBOL_HASH_ASSIGN = 39,               /* HASH_ASSIGN  */
  YYSYMBOL_LIST = 40,                      /* LIST  */
  YYSYMBOL_ARRAY = 41,                     /* ARRAY  */
  YYSYMBOL_CLASS_SCOPE = 42,               /* CLASS_SCOPE  */
  YYSYMBOL_43_ = 43,                       /* ','  */
  YYSYMBOL_PRINT = 44,                     /* PRINT  */
  YYSYMBOL_45_ = 45,                       /* '='  */
  YYSYMBOL_PLUS_EQ = 46,                   /* PLUS_EQ  */
  YYSYMBOL_MINUS_EQ = 47,                  /* MINUS_EQ  */
  YYSYMBOL_MUL_EQ = 48,                    /* MUL_EQ  */
  YYSYMBOL_DIV_EQ = 49,                    /* DIV_EQ  */
  YYSYMBOL_CONCAT_EQ = 50,                 /* CONCAT_EQ  */
  YYSYMBOL_MOD_EQ = 51,                    /* MOD_EQ  */
  YYSYMBOL_AND_EQ = 52,                    /* AND_EQ  */
  YYSYMBOL_OR_EQ = 53,                     /* OR_EQ  */
  YYSYMBOL_XOR_EQ = 54,                    /* XOR_EQ  */
  YYSYMBOL_SL_EQ = 55,                     /* SL_EQ  */
  YYSYMBOL_SR_EQ = 56,                     /* SR_EQ  */
  YYSYMBOL_57_ = 57,                       /* '?'  */
  YYSYMBOL_58_ = 58,                       /* ':'  */
  YYSYMBOL_LOG_OR = 59,                    /* LOG_OR  */
  YYSYMBOL_LOG_XOR = 60,                   /* LOG_XOR  */
  YYSYMBOL_LOG_AND = 61,                   /* LOG_AND  */
  YYSYMBOL_BOOLEAN_OR = 62,                /* BOOLEAN_OR  */
  YYSYMBOL_BOOLEAN_AND = 63,               /* BOOLEAN_AND  */
  YYSYMBOL_64_ = 64,                       /* '|'  */
  YYSYMBOL_65_ = 65,                       /* '^'  */
  YYSYMBOL_66_ = 66,                       /* '&'  */
  YYSYMBOL_IS_EQ = 67,                     /* IS_EQ  */
  YYSYMBOL_IS_NOEQUAL = 68,                /* IS_NOEQUAL  */
  YYSYMBOL_IS_IDENTICAL = 69,              /* IS_IDENTICAL  */
  YYSYMBOL_IS_NOIDENTICAL = 70,            /* IS_NOIDENTICAL  */
  YYSYMBOL_71_ = 71,                       /* '<'  */
  YYSYMBOL_IS_SMALLER_OR_EQ = 72,          /* IS_SMALLER_OR_EQ  */
  YYSYMBOL_73_ = 73,                       /* '>'  */
  YYSYMBOL_IS_GREATER_OR_EQ = 74,          /* IS_GREATER_OR_EQ  */
  YYSYMBOL_SL = 75,                        /* SL  */
  YYSYMBOL_SR = 76,                        /* SR  */
  YYSYMBOL_77_ = 77,                       /* '+'  */
  YYSYMBOL_78_ = 78,                       /* '-'  */
  YYSYMBOL_79_ = 79,                       /* '.'  */
  YYSYMBOL_80_ = 80,                       /* '*'  */
  YYSYMBOL_81_ = 81,                       /* '/'  */
  YYSYMBOL_82_ = 82,                       /* '%'  */
  YYSYMBOL_83_ = 83,                       /* '!'  */
  YYSYMBOL_INSTANCEOF = 84,                /* INSTANCEOF  */
  YYSYMBOL_85_ = 85,                       /* '~'  */
  YYSYMBOL_INC = 86,                       /* INC  */
  YYSYMBOL_DEC = 87,                       /* DEC  */
  YYSYMBOL_INT_CAST = 88,                  /* INT_CAST  */
  YYSYMBOL_DOUBLE_CAST = 89,               /* DOUBLE_CAST  */
  YYSYMBOL_STRING_CAST = 90,               /* STRING_CAST  */
  YYSYMBOL_ARRAY_CAST = 91,                /* ARRAY_CAST  */
  YYSYMBOL_OBJECT_CAST = 92,               /* OBJECT_CAST  */
  YYSYMBOL_BOOL_CAST = 93,                 /* BOOL_CAST  */
  YYSYMBOL_UNSET_CAST = 94,                /* UNSET_CAST  */
  YYSYMBOL_95_ = 95,                       /* '@'  */
  YYSYMBOL_96_ = 96,                       /* '['  */
  YYSYMBOL_NEW = 97,                       /* NEW  */
  YYSYMBOL_CLONE = 98,                     /* CLONE  */
  YYSYMBOL_ELSEIF = 99,                    /* ELSEIF  */
  YYSYMBOL_ELSE = 100,                     /* ELSE  */
  YYSYMBOL_ENDIF = 101,                    /* ENDIF  */
  YYSYMBOL_STATIC = 102,                   /* STATIC  */
  YYSYMBOL_ABSTRACT = 103,                 /* ABSTRACT  */
  YYSYMBOL_FINAL = 104,                    /* FINAL  */
  YYSYMBOL_PRIVATE = 105,                  /* PRIVATE  */
  YYSYMBOL_PROTECTED = 106,                /* PROTECTED  */
  YYSYMBOL_PUBLIC = 107,                   /* PUBLIC  */
  YYSYMBOL_START_SCRIPT = 108,             /* START_SCRIPT  */
  YYSYMBOL_END_SCRIPT = 109,               /* END_SCRIPT  */
  YYSYMBOL_110_ = 110,                     /* '{'  */
  YYSYMBOL_111_ = 111,                     /* '}'  */
  YYSYMBOL_112_ = 112,                     /* ';'  */
  YYSYMBOL_113_ = 113,                     /* '('  */
  YYSYMBOL_114_ = 114,                     /* ')'  */
  YYSYMBOL_115_ = 115,                     /* ']'  */
  YYSYMBOL_116_ = 116,                     /* '$'  */
  YYSYMBOL_YYACCEPT = 117,                 /* $accept  */
  YYSYMBOL_program_tree = 118,             /* program_tree  */
  YYSYMBOL_top_statement_list = 119,       /* top_statement_list  */
  YYSYMBOL_top_statement = 120,            /* top_statement  */
  YYSYMBOL_statement = 121,                /* statement  */
  YYSYMBOL_decl_list = 122,                /* decl_list  */
  YYSYMBOL_expr_list = 123,                /* expr_list  */
  YYSYMBOL_variable_list = 124,            /* variable_list  */
  YYSYMBOL_global_var_list = 125,          /* global_var_list  */
  YYSYMBOL_global_var = 126,               /* global_var  */
  YYSYMBOL_static_var_list = 127,          /* static_var_list  */
  YYSYMBOL_static_var = 128,               /* static_var  */
  YYSYMBOL_function_decl_statement = 129,  /* function_decl_statement  */
  YYSYMBOL_130_1 = 130,                    /* $@1  */
  YYSYMBOL_parameter_list = 131,           /* parameter_list  */
  YYSYMBOL_optional_class_type = 132,      /* optional_class_type  */
  YYSYMBOL_for_statement = 133,            /* for_statement  */
  YYSYMBOL_foreach_statement = 134,        /* foreach_statement  */
  YYSYMBOL_for_expr = 135,                 /* for_expr  */
  YYSYMBOL_elseif_list = 136,              /* elseif_list  */
  YYSYMBOL_else_statement = 137,           /* else_statement  */
  YYSYMBOL_while_statement = 138,          /* while_statement  */
  YYSYMBOL_switch_case_list = 139,         /* switch_case_list  */
  YYSYMBOL_case_list = 140,                /* case_list  */
  YYSYMBOL_case_list_item = 141,           /* case_list_item  */
  YYSYMBOL_case_separator = 142,           /* case_separator  */
  YYSYMBOL_const_value = 143,              /* const_value  */
  YYSYMBOL_variable = 144,                 /* variable  */
  YYSYMBOL_deref_variable = 145,           /* deref_variable  */
  YYSYMBOL_function_call = 146,            /* function_call  */
  YYSYMBOL_func_param_list = 147,          /* func_param_list  */
  YYSYMBOL_expr = 148,                     /* expr  */
  YYSYMBOL_exit_expr = 149,                /* exit_expr  */
  YYSYMBOL_assignment_list = 150,          /* assignment_list  */
  YYSYMBOL_assignment_list_element = 151,  /* assignment_list_element  */
  YYSYMBOL_array_pair_list = 152,          /* array_pair_list  */
  YYSYMBOL_array_elem = 153                /* array_elem  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  4
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3048

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  117
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  37
/* YYNRULES -- Number of rules.  */
#define YYNRULES  169
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  385

#define YYMAXUTOK   345


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    83,     2,     2,   116,    82,    66,     2,
     113,   114,    80,    77,    43,    78,    79,    81,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    58,   112,
      71,    45,    73,    57,    95,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    96,     2,   115,    65,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   110,    64,   111,    85,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    44,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      59,    60,    61,    62,    63,    67,    68,    69,    70,    72,
      74,    75,    76,    84,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   142,   142,   146,   147,   152,   153,   154,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   179,   182,   185,   186,
     187,   190,   191,   194,   195,   204,   205,   211,   212,   216,
     231,   232,   235,   236,   244,   244,   255,   259,   260,   261,
     262,   263,   267,   268,   272,   273,   277,   278,   281,   282,
     286,   287,   291,   292,   295,   296,   300,   301,   302,   303,
     307,   308,   323,   324,   327,   328,   332,   333,   334,   335,
     338,   339,   340,   344,   345,   346,   347,   348,   352,   353,
     354,   357,   358,   359,   360,   361,   366,   367,   368,   369,
     370,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   387,   388,   389,   390,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     428,   429,   430,   432,   433,   434,   437,   438,   439,   442,
     443,   447,   448,   449,   452,   453,   462,   463,   464,   465
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "FNUMBER", "DNUMBER",
  "STRING", "IDENT", "VARIABLE", "T_ECHO", "EXIT", "IF", "DO", "WHILE",
  "ENDWHILE", "FOR", "ENDFOR", "FOREACH", "ENDFOREACH", "DECLARE",
  "ENDDECLARE", "AS", "CONST", "GLOBAL", "UNSET", "ISSET", "EMPTY",
  "SWITCH", "ENDSWITCH", "CASE", "DEFAULT", "BREAK", "CONTINUE",
  "FUNCTION", "RETURN", "CLASS", "INTERFACE", "EXTENDS", "IMPLEMENTS",
  "OBJECT_OPERATOR", "HASH_ASSIGN", "LIST", "ARRAY", "CLASS_SCOPE", "','",
  "PRINT", "'='", "PLUS_EQ", "MINUS_EQ", "MUL_EQ", "DIV_EQ", "CONCAT_EQ",
  "MOD_EQ", "AND_EQ", "OR_EQ", "XOR_EQ", "SL_EQ", "SR_EQ", "'?'", "':'",
  "LOG_OR", "LOG_XOR", "LOG_AND", "BOOLEAN_OR", "BOOLEAN_AND", "'|'",
  "'^'", "'&'", "IS_EQ", "IS_NOEQUAL", "IS_IDENTICAL", "IS_NOIDENTICAL",
  "'<'", "IS_SMALLER_OR_EQ", "'>'", "IS_GREATER_OR_EQ", "SL", "SR", "'+'",
  "'-'", "'.'", "'*'", "'/'", "'%'", "'!'", "INSTANCEOF", "'~'", "INC",
  "DEC", "INT_CAST", "DOUBLE_CAST", "STRING_CAST", "ARRAY_CAST",
  "OBJECT_CAST", "BOOL_CAST", "UNSET_CAST", "'@'", "'['", "NEW", "CLONE",
  "ELSEIF", "ELSE", "ENDIF", "STATIC", "ABSTRACT", "FINAL", "PRIVATE",
  "PROTECTED", "PUBLIC", "START_SCRIPT", "END_SCRIPT", "'{'", "'}'", "';'",
  "'('", "')'", "']'", "'$'", "$accept", "program_tree",
  "top_statement_list", "top_statement", "statement", "decl_list",
  "expr_list", "variable_list", "global_var_list", "global_var",
  "static_var_list", "static_var", "function_decl_statement", "$@1",
  "parameter_list", "optional_class_type", "for_statement",
  "foreach_statement", "for_expr", "elseif_list", "else_statement",
  "while_statement", "switch_case_list", "case_list", "case_list_item",
  "case_separator", "const_value", "variable", "deref_variable",
  "function_call", "func_param_list", "expr", "exit_expr",
  "assignment_list", "assignment_list_element", "array_pair_list",
  "array_elem", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,    44,   298,    61,   299,   300,   301,   302,
     303,   304,   305,   306,   307,   308,   309,    63,    58,   310,
     311,   312,   313,   314,   124,    94,    38,   315,   316,   317,
     318,    60,   319,    62,   320,   321,   322,    43,    45,    46,
      42,    47,    37,    33,   323,   126,   324,   325,   326,   327,
     328,   329,   330,   331,   332,    64,    91,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     123,   125,    59,    40,    41,    93,    36
};
#endif

#define YYPACT_NINF (-335)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-53)

#define yytable_value_is_error(Yyn) \
  ((Yyn) == YYTABLE_NINF)

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -94,  -335,    54,   344,  -335,  -335,  -335,  -335,   -32,  -335,
    2566,   -64,   -57,  1940,   -49,   -44,   -37,    42,    59,    70,
      78,  1996,  2054,    14,  2110,    88,    90,  2566,  2566,  2566,
    2566,  2566,    34,    34,  2566,  2566,  2566,  2566,  2566,  2566,
      61,  -335,  -335,  -335,  -335,  2566,    56,  -335,  -335,  -335,
    -335,   123,    49,  -335,  1356,   157,  2168,     0,  2837,  2224,
    -335,  2566,   192,  2566,  2566,  2566,   205,  -335,    36,  -335,
      34,  2566,  -335,  2624,  -335,  2650,  -335,   208,  -335,  2678,
      31,  2282,  2837,   118,   118,  -335,  -335,   173,  -335,   -36,
    -335,  -335,  -335,  -335,  -335,  -335,  -335,   171,    50,  -335,
     458,   572,   558,  2566,  2338,  2566,  2566,  2566,  2566,  2566,
    2566,  2566,  2566,  2566,  2566,  2566,  -335,  -335,   211,   212,
    2396,  2566,  2566,  2566,  2566,  2566,  2566,  2566,  2566,  2566,
    2566,  2566,  2566,  2566,  2566,  2566,  2566,  2566,  2566,  2566,
    2566,  2566,  2566,  2566,  2566,  2566,  2566,  -335,  -335,    34,
     -31,  2837,  2566,  -335,  -335,   672,   786,   106,   900,   177,
     109,   451,   178,    -1,    59,  -335,    27,  -335,  1014,  -335,
    -335,   111,   113,  -335,   116,  -335,    30,  -335,    34,  2785,
      35,  -335,   216,   191,    61,  -335,  -335,  -335,  -335,  2704,
      34,  2837,  2837,  2837,  2837,  2837,  2837,  2837,  2837,  2837,
    2837,  2837,  2837,   117,   124,  -335,   330,  2732,  2811,  2884,
    2906,  2927,  2947,  2966,  1478,  1591,  1704,  1818,  1818,  1818,
    1818,   202,   202,   202,   202,   108,   108,   118,   118,   118,
    -335,  -335,  -335,  -335,  2452,  -335,  2837,  -335,  1940,  2566,
    1484,  2566,    34,   191,   225,  1598,  -335,    34,   126,   -47,
     146,   146,    31,    31,   194,  -335,  2510,  2282,  -335,  -335,
    -335,  -335,  -335,  -335,  -335,  2168,  2168,  -335,  -335,  2566,
      34,  2837,  -335,  1128,  -335,  -335,  -335,   128,   -30,  -335,
     197,  -335,  -335,  -335,  -335,   131,   133,  -335,  -335,    43,
     136,    46,    51,  -335,  2566,    34,  2837,  -335,    53,    67,
    2861,  -335,   -73,   134,   686,  2566,    45,  1712,   191,   800,
    -335,    17,  -335,   -23,   230,   137,  -335,   241,   142,  -335,
    2837,  -335,  -335,  -335,   140,  1940,  -335,  -335,   144,   150,
      34,   151,  -335,  -335,  -335,  -335,  -335,   179,   149,  2566,
    -335,   -45,   -21,  -335,   147,  -335,  -335,  -335,  2566,  -335,
    -335,  1826,   152,  1712,   914,   158,  -335,  2837,  -335,  -335,
    -335,  -335,  -335,   251,  1028,  1142,  1242,  -335,  -335,  -335,
    1712,  -335,   159,  -335,  1370,  -335,  -335,  -335,  1940,  1256,
    -335,  -335,  -335,   174,  -335
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     4,     0,     0,     1,    76,    77,    78,    79,    83,
       0,   158,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     4,     2,     4,    30,     0,     0,     3,     5,     7,
     153,    97,    80,    99,     0,     0,    95,     0,    33,     0,
     151,     0,     0,     0,    59,     0,     0,    39,     0,    37,
       0,     0,    19,     0,    17,     0,    44,     0,    21,     0,
     163,     0,   155,   132,   133,   134,   135,     0,   113,    80,
     115,   146,   147,   148,   149,   150,   152,    42,     0,    40,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   112,   114,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     9,    81,     0,
       0,    91,     0,    23,   157,     0,     0,     0,     0,    58,
       0,     0,     0,     0,     0,    10,     0,    35,     0,    20,
      18,     0,     0,    22,     0,   161,     0,   159,     0,   166,
       0,   164,     0,     0,     0,    11,     6,     8,   144,     0,
       0,    98,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,    82,     0,    84,     0,     0,     0,   118,
     120,   119,   116,   117,   121,   123,   122,   138,   139,   136,
     137,   140,   141,   142,   143,   130,   131,   125,   126,   124,
     127,   128,   129,    92,     0,    88,    34,   156,     0,     0,
       0,    59,     0,     0,     0,     0,    38,     0,     0,     0,
      51,    51,   163,   163,     0,   169,     0,     0,   154,    82,
      79,    43,    41,    87,   100,    95,    95,    85,    86,     0,
       0,    93,    61,     0,     4,    64,    13,     0,     0,    31,
       0,     4,    28,    36,    24,    70,    70,    16,    53,     0,
       0,     0,     0,   160,     0,     0,   167,   165,     0,     0,
     145,    94,    62,     0,     0,    59,     0,     0,     0,     0,
      70,     0,    70,     0,    52,     0,    47,     0,     0,   162,
      96,   168,    90,    89,     0,     0,    12,    14,     0,     0,
       0,     0,     4,    56,    25,    32,    29,     0,     0,     0,
      73,     0,     0,    66,     0,     4,    48,     4,     0,    63,
      65,     0,     0,     0,     0,     0,    68,    72,    74,    75,
       4,    67,    49,     0,     0,     0,     0,     4,    54,    15,
       0,    26,     0,    69,    71,    50,    45,    46,     0,     0,
      27,    57,    60,     0,    55
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -335,  -335,   -40,  -335,   -13,  -335,   259,  -335,  -335,   125,
    -335,   103,  -335,  -335,    39,   -19,  -335,  -334,  -149,  -335,
    -335,  -335,  -335,  -128,  -335,  -335,  -166,     2,    15,  -335,
    -204,    -6,  -335,    41,    38,  -335,    44
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    47,    48,   163,   159,   166,    68,    69,
      98,    99,    49,   171,   289,   290,   369,   334,   160,   302,
     326,   276,   287,   311,   341,   360,    50,    51,    52,    53,
     150,    54,    60,   176,   177,   180,   181
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      62,   100,   182,   101,    58,   339,   340,   339,   340,   306,
      55,   285,   234,   358,     1,    73,    75,   261,    79,   371,
      76,    82,    83,    84,    85,    86,   324,   325,    91,    92,
      93,    94,    95,    96,    88,    90,   380,    87,     9,   102,
      87,     9,   244,   152,   338,   339,   340,    89,    89,    59,
     151,    87,     9,   155,     4,   156,    61,   158,    58,   161,
     120,   298,   299,   286,    63,   168,    67,   359,    97,    64,
     247,   174,   167,   253,   121,   179,    65,   279,   257,   164,
      77,    56,   175,   235,   307,    89,   314,   118,   343,   314,
     361,   119,   277,   184,   253,    89,   234,   189,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     234,   330,   153,   245,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   248,   335,   316,   254,   120,   236,    46,   165,   258,
      46,   233,   288,   -52,   362,    66,   329,   315,   313,   121,
     318,    46,   185,   148,    89,   319,   103,   322,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     255,   323,   337,    70,   342,   141,   142,   143,   144,   145,
     146,    71,   264,    89,     5,     6,     7,   260,   144,   145,
     146,    80,   317,    81,   157,    89,   355,   339,   340,   116,
     117,   162,   -52,   363,   172,    55,   183,   203,   204,   239,
     152,   241,   259,   243,   250,   272,   251,   275,   271,   252,
     265,   280,   282,   273,   304,    58,   288,   266,   284,   294,
     305,   309,   308,   310,   278,   312,   327,   345,   346,   283,
     296,   179,   347,   348,   175,   175,   350,    89,   375,   151,
     151,   356,    89,   300,   351,   353,   370,    89,    89,    57,
     373,   381,   301,   -53,   -53,   -53,   -53,   139,   140,   141,
     142,   143,   144,   145,   146,    89,   384,   262,   320,   246,
     291,   293,   354,   292,   333,   344,     0,   321,     0,    58,
       0,   297,     0,     0,     0,   364,     0,   365,   331,     0,
      89,     0,   349,     0,     0,     0,     0,     0,     0,     0,
     374,    89,     0,     0,     0,     0,     0,   379,     0,     0,
       0,     0,   352,   357,     0,     0,     0,     0,   368,     0,
     333,     0,   366,     0,     0,    89,     0,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,   333,    15,     0,
      16,     0,    17,     0,     0,   382,    18,    19,     0,     0,
      20,     0,     0,     0,    21,    22,    23,    24,     0,     0,
       0,     0,     0,     0,    25,    26,     0,   122,    27,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,     0,     0,     0,     0,     0,     0,     0,
       0,    28,    29,     0,     0,     0,     0,    30,     0,    31,
      32,    33,    34,    35,    36,     0,     0,    37,    38,    39,
       0,     0,     0,     0,     0,   267,    40,     0,     0,     0,
       0,     0,    41,    42,    43,     0,    44,    45,     0,     0,
      46,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,   242,    15,     0,    16,     0,    17,     0,     0,     0,
      18,    19,     0,     0,    20,     0,     0,     0,    21,    22,
      23,    24,     0,     0,     0,     0,     0,     0,    25,    26,
       0,     0,    27,     0,     0,     0,     0,     0,   122,     0,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,     0,    28,    29,     0,     0,     0,
       0,    30,     0,    31,    32,    33,    34,    35,    36,     0,
       0,    37,    38,    39,     0,     0,     0,     0,     0,     0,
      40,     0,     0,     0,     0,     0,    41,   186,    43,     0,
      44,    45,     0,     0,    46,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,     0,    15,     0,    16,     0,
      17,     0,     0,     0,    18,    19,     0,     0,    20,     0,
       0,     0,    21,    22,    23,    24,     0,     0,     0,     0,
       0,     0,    25,    26,     0,   122,    27,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,     0,     0,     0,     0,     0,     0,     0,     0,    28,
      29,     0,     0,     0,     0,    30,     0,    31,    32,    33,
      34,    35,    36,     0,     0,    37,    38,    39,     0,     0,
       0,     0,   188,     0,    40,     0,     0,     0,     0,     0,
      41,     0,    43,   187,    44,    45,     0,     0,    46,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,   328,
      15,     0,    16,     0,    17,     0,     0,     0,    18,    19,
       0,     0,    20,     0,     0,     0,    21,    22,    23,    24,
       0,     0,     0,     0,     0,     0,    25,    26,     0,   122,
      27,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,     0,     0,     0,     0,     0,
       0,     0,     0,    28,    29,     0,     0,     0,     0,    30,
       0,    31,    32,    33,    34,    35,    36,     0,     0,    37,
      38,    39,     0,     0,     0,     0,   237,     0,    40,     0,
       0,     0,     0,     0,    41,     0,    43,     0,    44,    45,
       0,     0,    46,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,     0,    15,     0,    16,     0,    17,   336,
       0,     0,    18,    19,     0,     0,    20,     0,     0,     0,
      21,    22,    23,    24,     0,     0,     0,     0,     0,     0,
      25,    26,     0,   122,    27,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,     0,
       0,     0,     0,     0,     0,     0,     0,    28,    29,     0,
       0,     0,     0,    30,     0,    31,    32,    33,    34,    35,
      36,     0,     0,    37,    38,    39,     0,     0,     0,     0,
     238,     0,    40,     0,     0,     0,     0,     0,    41,     0,
      43,     0,    44,    45,     0,     0,    46,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,     0,    15,     0,
      16,   372,    17,     0,     0,     0,    18,    19,     0,     0,
      20,     0,     0,     0,    21,    22,    23,    24,     0,     0,
       0,     0,     0,     0,    25,    26,     0,   122,    27,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,     0,     0,     0,     0,     0,     0,     0,
       0,    28,    29,     0,     0,     0,     0,    30,     0,    31,
      32,    33,    34,    35,    36,     0,     0,    37,    38,    39,
       0,     0,     0,     0,   240,     0,    40,     0,     0,     0,
       0,     0,    41,     0,    43,     0,    44,    45,     0,     0,
      46,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,     0,    15,     0,    16,     0,    17,     0,     0,     0,
      18,    19,     0,     0,    20,     0,     0,     0,    21,    22,
      23,    24,     0,     0,     0,     0,     0,     0,    25,    26,
       0,   122,    27,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,     0,     0,     0,
       0,     0,     0,     0,     0,    28,    29,     0,     0,     0,
       0,    30,     0,    31,    32,    33,    34,    35,    36,     0,
       0,    37,    38,    39,     0,     0,     0,     0,   249,     0,
      40,     0,     0,     0,     0,     0,    41,     0,    43,   376,
      44,    45,     0,     0,    46,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,     0,    15,     0,    16,     0,
      17,     0,     0,     0,    18,    19,     0,     0,    20,     0,
       0,     0,    21,    22,    23,    24,     0,     0,     0,     0,
       0,     0,    25,    26,     0,   122,    27,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,     0,     0,     0,     0,     0,     0,     0,     0,    28,
      29,     0,     0,     0,     0,    30,     0,    31,    32,    33,
      34,    35,    36,     0,     0,    37,    38,    39,     0,     0,
       0,     0,   303,     0,    40,     0,     0,     0,     0,     0,
      41,     0,    43,   377,    44,    45,     0,     0,    46,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,     0,
      15,   383,    16,     0,    17,     0,     0,     0,    18,    19,
       0,     0,    20,     0,     0,     0,    21,    22,    23,    24,
       0,     0,     0,     0,     0,     0,    25,    26,     0,   122,
      27,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,     0,     0,     0,     0,     0,
       0,     0,     0,    28,    29,     0,     0,     0,     0,    30,
       0,    31,    32,    33,    34,    35,    36,     0,     0,    37,
      38,    39,     0,     0,     0,     0,   378,     0,    40,     0,
       0,     0,     0,     0,    41,     0,    43,     0,    44,    45,
       0,     0,    46,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,     0,    15,     0,    16,     0,    17,     0,
       0,     0,    18,    19,     0,     0,    20,     0,     0,     0,
      21,    22,    23,    24,     0,     0,     0,     0,     0,     0,
      25,    26,     0,   122,    27,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,     0,
       0,     0,     0,     0,     0,     0,     0,    28,    29,     0,
       0,     0,     0,    30,     0,    31,    32,    33,    34,    35,
      36,     0,     0,    37,    38,    39,     0,     0,   147,     0,
       0,     0,    40,     0,     0,     0,     0,     0,    41,     0,
      43,     0,    44,    45,     0,     0,    46,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,     0,    15,     0,
      16,     0,    17,     0,     0,     0,    18,    19,     0,     0,
      20,     0,     0,     0,    21,    22,     0,    24,     0,     0,
       0,     0,     0,     0,    25,    26,     0,     0,    27,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   274,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,    28,    29,     0,     0,     0,     0,    30,     0,    31,
      32,    33,    34,    35,    36,     0,     0,    37,    38,    39,
       0,     0,     0,     0,     0,     0,    40,     0,     0,     0,
       0,     0,     0,     0,    43,     0,    44,    45,     0,     0,
      46,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,     0,    15,     0,    16,     0,    17,     0,     0,     0,
      18,    19,     0,     0,    20,     0,     0,     0,    21,    22,
       0,    24,     0,     0,     0,     0,     0,     0,    25,    26,
       0,     0,    27,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   281,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,     0,    28,    29,     0,     0,     0,
       0,    30,     0,    31,    32,    33,    34,    35,    36,     0,
       0,    37,    38,    39,     0,     0,     0,     0,     0,     0,
      40,     0,     0,     0,     0,     0,     0,     0,    43,     0,
      44,    45,     0,     0,    46,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,     0,    15,     0,    16,     0,
      17,     0,     0,     0,    18,    19,     0,     0,    20,     0,
       0,     0,    21,    22,     0,    24,     0,     0,     0,     0,
       0,     0,    25,    26,     0,     0,    27,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     332,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,     0,     0,    28,
      29,     0,     0,     0,     0,    30,     0,    31,    32,    33,
      34,    35,    36,     0,     0,    37,    38,    39,     0,     0,
       0,     0,     0,     0,    40,     0,     0,     0,     0,     0,
       0,     0,    43,     0,    44,    45,     0,     0,    46,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,     0,
      15,     0,    16,     0,    17,     0,     0,     0,    18,    19,
       0,     0,    20,     0,     0,     0,    21,    22,     0,    24,
       0,     0,     0,     0,     0,     0,    25,    26,     0,     0,
      27,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   367,   -53,   -53,   -53,   -53,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,     0,     0,    28,    29,     0,     0,     0,     0,    30,
       0,    31,    32,    33,    34,    35,    36,     0,     0,    37,
      38,    39,     0,     0,     0,     0,     0,     0,    40,     0,
       0,     0,     0,     0,     0,     0,    43,     0,    44,    45,
       0,     0,    46,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,     0,    15,     0,    16,     0,    17,     0,
       0,     0,    18,    19,     0,     0,    20,     0,     0,     0,
      21,    22,     0,    24,     0,     0,     0,     0,     0,     0,
      25,    26,     0,     0,    27,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     5,
       6,     7,     8,     9,     0,    11,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    28,    29,     0,
       0,     0,     0,    30,     0,    31,    32,    33,    34,    35,
      36,     0,     0,    37,    38,    39,    25,    26,     0,     0,
      27,     0,    40,     0,     0,     0,     0,     0,     0,     0,
      43,     0,    44,    45,     0,     0,    46,     5,     6,     7,
       8,     9,     0,    11,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    28,    29,     0,     0,     0,     0,    30,
       0,    31,    32,    33,    34,    35,    36,     0,     0,    37,
      38,    39,     0,     0,    25,    26,     0,     0,    27,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    72,    45,
       0,     0,    46,     5,     6,     7,     8,     9,     0,    11,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    28,    29,     0,     0,     0,     0,    30,     0,    31,
      32,    33,    34,    35,    36,     0,     0,    37,    38,    39,
      25,    26,     0,     0,    27,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    74,    45,     0,     0,
      46,     5,     6,     7,     8,     9,     0,    11,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    28,    29,     0,
       0,     0,     0,    30,     0,    31,    32,    33,    34,    35,
      36,     0,     0,    37,    38,    39,     0,     0,    25,    26,
       0,     0,    27,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    78,    45,     0,     0,    46,     5,     6,     7,
       8,     9,     0,    11,   149,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    28,    29,     0,     0,     0,
       0,    30,     0,    31,    32,    33,    34,    35,    36,     0,
       0,    37,    38,    39,    25,    26,     0,     0,    27,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,     0,     0,    46,     5,     6,     7,     8,     9,
       0,    11,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    28,    29,     0,     0,     0,     0,    30,     0,    31,
      32,    33,    34,    35,    36,     0,     0,    37,    38,    39,
       0,     0,    25,    26,     0,     0,    27,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    45,   154,     0,
      46,     5,     6,     7,     8,     9,     0,    11,   178,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    28,
      29,     0,     0,     0,     0,    30,     0,    31,    32,    33,
      34,    35,    36,     0,     0,    37,    38,    39,    25,    26,
       0,     0,    27,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,     0,     0,    46,     5,
       6,     7,     8,     9,   190,    11,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    28,    29,     0,     0,     0,
       0,    30,     0,    31,    32,    33,    34,    35,    36,     0,
       0,    37,    38,    39,     0,     0,    25,    26,     0,     0,
      27,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    45,     0,     0,    46,     5,     6,     7,     8,     9,
       0,    11,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    28,    29,     0,     0,     0,     0,    30,
       0,    31,    32,    33,    34,    35,    36,     0,     0,    37,
      38,    39,    25,    26,     0,     0,    27,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
       0,   205,    46,     5,     6,     7,     8,     9,   270,    11,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    28,
      29,     0,     0,     0,     0,    30,     0,    31,    32,    33,
      34,    35,    36,     0,     0,    37,    38,    39,     0,     0,
      25,    26,     0,     0,    27,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    45,     0,     0,    46,     5,
       6,     7,     8,     9,     0,    11,   295,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    28,    29,     0,
       0,     0,     0,    30,     0,    31,    32,    33,    34,    35,
      36,     0,     0,    37,    38,    39,    25,    26,     0,     0,
      27,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    45,     0,     0,    46,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    28,    29,     0,     0,     0,     0,    30,
       0,    31,    32,    33,    34,    35,    36,     0,     0,    37,
      38,    39,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
       0,   122,    46,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   122,     0,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,     0,     0,   122,   169,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   122,   170,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,     0,     0,   122,
     173,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   263,     0,     0,     0,     0,
       0,     0,     0,     0,   256,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   122,   268,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   122,   269,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   122,     0,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146
};

static const yytype_int16 yycheck[] =
{
      13,    41,    38,    43,    10,    28,    29,    28,    29,    39,
      42,    58,    43,    58,   108,    21,    22,   183,    24,   353,
       6,    27,    28,    29,    30,    31,    99,   100,    34,    35,
      36,    37,    38,    39,    32,    33,   370,     6,     7,    45,
       6,     7,    43,    43,    27,    28,    29,    32,    33,   113,
      56,     6,     7,    59,     0,    61,   113,    63,    64,    65,
      96,   265,   266,   110,   113,    71,     7,   112,     7,   113,
      43,    40,    70,    43,   110,    81,   113,   243,    43,    43,
      66,   113,    80,   114,   114,    70,    43,    38,   111,    43,
     111,    42,   241,    43,    43,    80,    43,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
      43,    66,   112,   114,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   114,   308,     7,   114,    96,   152,   116,   112,   114,
     116,   149,     6,     7,     7,   113,   305,   114,   286,   110,
     114,   116,   112,     6,   149,   114,   110,   114,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
     178,   114,   310,   113,   312,    77,    78,    79,    80,    81,
      82,   113,   190,   178,     3,     4,     5,     6,    80,    81,
      82,   113,    66,   113,    12,   190,    27,    28,    29,    86,
      87,     6,    66,    66,     6,    42,    45,     6,     6,   113,
      43,   112,     6,    45,   113,   238,   113,   240,   234,   113,
     113,     6,   245,   239,   274,   241,     6,   113,   112,    45,
     112,   281,    45,   112,   242,   112,   112,   110,     7,   247,
     256,   257,   110,   113,   252,   253,   112,   242,     7,   265,
     266,   112,   247,   269,   114,   114,   114,   252,   253,    10,
     112,   112,   270,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,   270,   112,   184,   294,   164,
     251,   253,   332,   252,   307,   314,    -1,   295,    -1,   305,
      -1,   257,    -1,    -1,    -1,   345,    -1,   347,   306,    -1,
     295,    -1,   325,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     360,   306,    -1,    -1,    -1,    -1,    -1,   367,    -1,    -1,
      -1,    -1,   330,   339,    -1,    -1,    -1,    -1,   351,    -1,
     353,    -1,   348,    -1,    -1,   330,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,   370,    14,    -1,
      16,    -1,    18,    -1,    -1,   378,    22,    23,    -1,    -1,
      26,    -1,    -1,    -1,    30,    31,    32,    33,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    -1,    57,    44,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    77,    78,    -1,    -1,    -1,    -1,    83,    -1,    85,
      86,    87,    88,    89,    90,    -1,    -1,    93,    94,    95,
      -1,    -1,    -1,    -1,    -1,   115,   102,    -1,    -1,    -1,
      -1,    -1,   108,   109,   110,    -1,   112,   113,    -1,    -1,
     116,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    20,    14,    -1,    16,    -1,    18,    -1,    -1,    -1,
      22,    23,    -1,    -1,    26,    -1,    -1,    -1,    30,    31,
      32,    33,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,    57,    -1,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    -1,    77,    78,    -1,    -1,    -1,
      -1,    83,    -1,    85,    86,    87,    88,    89,    90,    -1,
      -1,    93,    94,    95,    -1,    -1,    -1,    -1,    -1,    -1,
     102,    -1,    -1,    -1,    -1,    -1,   108,   109,   110,    -1,
     112,   113,    -1,    -1,   116,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    -1,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    -1,    -1,    26,    -1,
      -1,    -1,    30,    31,    32,    33,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    -1,    57,    44,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      78,    -1,    -1,    -1,    -1,    83,    -1,    85,    86,    87,
      88,    89,    90,    -1,    -1,    93,    94,    95,    -1,    -1,
      -1,    -1,   114,    -1,   102,    -1,    -1,    -1,    -1,    -1,
     108,    -1,   110,   111,   112,   113,    -1,    -1,   116,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    -1,    16,    -1,    18,    -1,    -1,    -1,    22,    23,
      -1,    -1,    26,    -1,    -1,    -1,    30,    31,    32,    33,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    -1,    57,
      44,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    77,    78,    -1,    -1,    -1,    -1,    83,
      -1,    85,    86,    87,    88,    89,    90,    -1,    -1,    93,
      94,    95,    -1,    -1,    -1,    -1,   114,    -1,   102,    -1,
      -1,    -1,    -1,    -1,   108,    -1,   110,    -1,   112,   113,
      -1,    -1,   116,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    -1,    16,    -1,    18,    19,
      -1,    -1,    22,    23,    -1,    -1,    26,    -1,    -1,    -1,
      30,    31,    32,    33,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    -1,    57,    44,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,    78,    -1,
      -1,    -1,    -1,    83,    -1,    85,    86,    87,    88,    89,
      90,    -1,    -1,    93,    94,    95,    -1,    -1,    -1,    -1,
     114,    -1,   102,    -1,    -1,    -1,    -1,    -1,   108,    -1,
     110,    -1,   112,   113,    -1,    -1,   116,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    -1,
      16,    17,    18,    -1,    -1,    -1,    22,    23,    -1,    -1,
      26,    -1,    -1,    -1,    30,    31,    32,    33,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    -1,    57,    44,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    77,    78,    -1,    -1,    -1,    -1,    83,    -1,    85,
      86,    87,    88,    89,    90,    -1,    -1,    93,    94,    95,
      -1,    -1,    -1,    -1,   114,    -1,   102,    -1,    -1,    -1,
      -1,    -1,   108,    -1,   110,    -1,   112,   113,    -1,    -1,
     116,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    -1,    16,    -1,    18,    -1,    -1,    -1,
      22,    23,    -1,    -1,    26,    -1,    -1,    -1,    30,    31,
      32,    33,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      -1,    57,    44,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    77,    78,    -1,    -1,    -1,
      -1,    83,    -1,    85,    86,    87,    88,    89,    90,    -1,
      -1,    93,    94,    95,    -1,    -1,    -1,    -1,   114,    -1,
     102,    -1,    -1,    -1,    -1,    -1,   108,    -1,   110,   111,
     112,   113,    -1,    -1,   116,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    -1,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    -1,    -1,    26,    -1,
      -1,    -1,    30,    31,    32,    33,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    -1,    57,    44,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      78,    -1,    -1,    -1,    -1,    83,    -1,    85,    86,    87,
      88,    89,    90,    -1,    -1,    93,    94,    95,    -1,    -1,
      -1,    -1,   114,    -1,   102,    -1,    -1,    -1,    -1,    -1,
     108,    -1,   110,   111,   112,   113,    -1,    -1,   116,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    -1,
      14,    15,    16,    -1,    18,    -1,    -1,    -1,    22,    23,
      -1,    -1,    26,    -1,    -1,    -1,    30,    31,    32,    33,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    -1,    57,
      44,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    77,    78,    -1,    -1,    -1,    -1,    83,
      -1,    85,    86,    87,    88,    89,    90,    -1,    -1,    93,
      94,    95,    -1,    -1,    -1,    -1,   114,    -1,   102,    -1,
      -1,    -1,    -1,    -1,   108,    -1,   110,    -1,   112,   113,
      -1,    -1,   116,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    -1,    16,    -1,    18,    -1,
      -1,    -1,    22,    23,    -1,    -1,    26,    -1,    -1,    -1,
      30,    31,    32,    33,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    -1,    57,    44,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,    78,    -1,
      -1,    -1,    -1,    83,    -1,    85,    86,    87,    88,    89,
      90,    -1,    -1,    93,    94,    95,    -1,    -1,   112,    -1,
      -1,    -1,   102,    -1,    -1,    -1,    -1,    -1,   108,    -1,
     110,    -1,   112,   113,    -1,    -1,   116,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    -1,
      16,    -1,    18,    -1,    -1,    -1,    22,    23,    -1,    -1,
      26,    -1,    -1,    -1,    30,    31,    -1,    33,    -1,    -1,
      -1,    -1,    -1,    -1,    40,    41,    -1,    -1,    44,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    58,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    77,    78,    -1,    -1,    -1,    -1,    83,    -1,    85,
      86,    87,    88,    89,    90,    -1,    -1,    93,    94,    95,
      -1,    -1,    -1,    -1,    -1,    -1,   102,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,    -1,   112,   113,    -1,    -1,
     116,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    -1,    14,    -1,    16,    -1,    18,    -1,    -1,    -1,
      22,    23,    -1,    -1,    26,    -1,    -1,    -1,    30,    31,
      -1,    33,    -1,    -1,    -1,    -1,    -1,    -1,    40,    41,
      -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    58,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    -1,    77,    78,    -1,    -1,    -1,
      -1,    83,    -1,    85,    86,    87,    88,    89,    90,    -1,
      -1,    93,    94,    95,    -1,    -1,    -1,    -1,    -1,    -1,
     102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   110,    -1,
     112,   113,    -1,    -1,   116,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    -1,    14,    -1,    16,    -1,
      18,    -1,    -1,    -1,    22,    23,    -1,    -1,    26,    -1,
      -1,    -1,    30,    31,    -1,    33,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    -1,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      58,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    -1,    -1,    77,
      78,    -1,    -1,    -1,    -1,    83,    -1,    85,    86,    87,
      88,    89,    90,    -1,    -1,    93,    94,    95,    -1,    -1,
      -1,    -1,    -1,    -1,   102,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   110,    -1,   112,   113,    -1,    -1,   116,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    -1,
      14,    -1,    16,    -1,    18,    -1,    -1,    -1,    22,    23,
      -1,    -1,    26,    -1,    -1,    -1,    30,    31,    -1,    33,
      -1,    -1,    -1,    -1,    -1,    -1,    40,    41,    -1,    -1,
      44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    58,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    -1,    -1,    77,    78,    -1,    -1,    -1,    -1,    83,
      -1,    85,    86,    87,    88,    89,    90,    -1,    -1,    93,
      94,    95,    -1,    -1,    -1,    -1,    -1,    -1,   102,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   110,    -1,   112,   113,
      -1,    -1,   116,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    -1,    14,    -1,    16,    -1,    18,    -1,
      -1,    -1,    22,    23,    -1,    -1,    26,    -1,    -1,    -1,
      30,    31,    -1,    33,    -1,    -1,    -1,    -1,    -1,    -1,
      40,    41,    -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,     6,     7,    -1,     9,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,    78,    -1,
      -1,    -1,    -1,    83,    -1,    85,    86,    87,    88,    89,
      90,    -1,    -1,    93,    94,    95,    40,    41,    -1,    -1,
      44,    -1,   102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     110,    -1,   112,   113,    -1,    -1,   116,     3,     4,     5,
       6,     7,    -1,     9,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    77,    78,    -1,    -1,    -1,    -1,    83,
      -1,    85,    86,    87,    88,    89,    90,    -1,    -1,    93,
      94,    95,    -1,    -1,    40,    41,    -1,    -1,    44,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   112,   113,
      -1,    -1,   116,     3,     4,     5,     6,     7,    -1,     9,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    77,    78,    -1,    -1,    -1,    -1,    83,    -1,    85,
      86,    87,    88,    89,    90,    -1,    -1,    93,    94,    95,
      40,    41,    -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   112,   113,    -1,    -1,
     116,     3,     4,     5,     6,     7,    -1,     9,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,    78,    -1,
      -1,    -1,    -1,    83,    -1,    85,    86,    87,    88,    89,
      90,    -1,    -1,    93,    94,    95,    -1,    -1,    40,    41,
      -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   112,   113,    -1,    -1,   116,     3,     4,     5,
       6,     7,    -1,     9,    66,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    77,    78,    -1,    -1,    -1,
      -1,    83,    -1,    85,    86,    87,    88,    89,    90,    -1,
      -1,    93,    94,    95,    40,    41,    -1,    -1,    44,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,    -1,    -1,   116,     3,     4,     5,     6,     7,
      -1,     9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    77,    78,    -1,    -1,    -1,    -1,    83,    -1,    85,
      86,    87,    88,    89,    90,    -1,    -1,    93,    94,    95,
      -1,    -1,    40,    41,    -1,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
     116,     3,     4,     5,     6,     7,    -1,     9,    66,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      78,    -1,    -1,    -1,    -1,    83,    -1,    85,    86,    87,
      88,    89,    90,    -1,    -1,    93,    94,    95,    40,    41,
      -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,    -1,    -1,   116,     3,
       4,     5,     6,     7,    66,     9,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    77,    78,    -1,    -1,    -1,
      -1,    83,    -1,    85,    86,    87,    88,    89,    90,    -1,
      -1,    93,    94,    95,    -1,    -1,    40,    41,    -1,    -1,
      44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   113,    -1,    -1,   116,     3,     4,     5,     6,     7,
      -1,     9,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    77,    78,    -1,    -1,    -1,    -1,    83,
      -1,    85,    86,    87,    88,    89,    90,    -1,    -1,    93,
      94,    95,    40,    41,    -1,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
      -1,   115,   116,     3,     4,     5,     6,     7,    66,     9,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      78,    -1,    -1,    -1,    -1,    83,    -1,    85,    86,    87,
      88,    89,    90,    -1,    -1,    93,    94,    95,    -1,    -1,
      40,    41,    -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,    -1,    -1,   116,     3,
       4,     5,     6,     7,    -1,     9,    66,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,    78,    -1,
      -1,    -1,    -1,    83,    -1,    85,    86,    87,    88,    89,
      90,    -1,    -1,    93,    94,    95,    40,    41,    -1,    -1,
      44,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   113,    -1,    -1,   116,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    77,    78,    -1,    -1,    -1,    -1,    83,
      -1,    85,    86,    87,    88,    89,    90,    -1,    -1,    93,
      94,    95,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,
      -1,    57,   116,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    57,    -1,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    -1,    -1,    57,   112,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    57,   112,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    -1,    -1,    57,
     112,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,   111,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    57,   111,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    57,    -1,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,   108,   118,   119,     0,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    14,    16,    18,    22,    23,
      26,    30,    31,    32,    33,    40,    41,    44,    77,    78,
      83,    85,    86,    87,    88,    89,    90,    93,    94,    95,
     102,   108,   109,   110,   112,   113,   116,   120,   121,   129,
     143,   144,   145,   146,   148,    42,   113,   123,   148,   113,
     149,   113,   121,   113,   113,   113,   113,     7,   125,   126,
     113,   113,   112,   148,   112,   148,     6,    66,   112,   148,
     113,   113,   148,   148,   148,   148,   148,     6,   144,   145,
     144,   148,   148,   148,   148,   148,   148,     7,   127,   128,
     119,   119,   148,   110,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    86,    87,    38,    42,
      96,   110,    57,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,   112,     6,    66,
     147,   148,    43,   112,   114,   148,   148,    12,   148,   123,
     135,   148,     6,   122,    43,   112,   124,   144,   148,   112,
     112,   130,     6,   112,    40,   144,   150,   151,    66,   148,
     152,   153,    38,    45,    43,   112,   109,   111,   114,   148,
      66,   148,   148,   148,   148,   148,   148,   148,   148,   148,
     148,   148,   148,     6,     6,   115,   148,   148,   148,   148,
     148,   148,   148,   148,   148,   148,   148,   148,   148,   148,
     148,   148,   148,   148,   148,   148,   148,   148,   148,   148,
     148,   148,   148,   144,    43,   114,   148,   114,   114,   113,
     114,   112,    20,    45,    43,   114,   126,    43,   114,   114,
     113,   113,   113,    43,   114,   144,    39,    43,   114,     6,
       6,   143,   128,   111,   144,   113,   113,   115,   111,    58,
      66,   148,   121,   148,    58,   121,   138,   135,   144,   143,
       6,    58,   121,   144,   112,    58,   110,   139,     6,   131,
     132,   131,   150,   151,    45,    66,   148,   153,   147,   147,
     148,   144,   136,   114,   119,   112,    39,   114,    45,   119,
     112,   140,   112,   140,    43,   114,     7,    66,   114,   114,
     148,   144,   114,   114,    99,   100,   137,   112,    13,   135,
      66,   144,    58,   121,   134,   143,    19,   140,    27,    28,
      29,   141,   140,   111,   132,   110,     7,   110,   113,   121,
     112,   114,   144,   114,   119,    27,   112,   148,    58,   112,
     142,   111,     7,    66,   119,   119,   148,    58,   121,   133,
     114,   134,    17,   112,   119,     7,   111,   111,   114,   119,
     134,   112,   121,    15,   112
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   117,   118,   119,   119,   120,   120,   120,   121,   121,
     121,   121,   121,   121,   121,   121,   121,   121,   121,   121,
     121,   121,   121,   121,   121,   121,   121,   121,   121,   121,
     121,   122,   122,   123,   123,   124,   124,   125,   125,   126,
     127,   127,   128,   128,   130,   129,   129,   131,   131,   131,
     131,   131,   132,   132,   133,   133,   134,   134,   135,   135,
     136,   136,   137,   137,   138,   138,   139,   139,   139,   139,
     140,   140,   141,   141,   142,   142,   143,   143,   143,   143,
     144,   144,   144,   145,   145,   145,   145,   145,   146,   146,
     146,   147,   147,   147,   147,   147,   148,   148,   148,   148,
     148,   148,   148,   148,   148,   148,   148,   148,   148,   148,
     148,   148,   148,   148,   148,   148,   148,   148,   148,   148,
     148,   148,   148,   148,   148,   148,   148,   148,   148,   148,
     148,   148,   148,   148,   148,   148,   148,   148,   148,   148,
     148,   148,   148,   148,   148,   148,   148,   148,   148,   148,
     148,   148,   148,   148,   148,   148,   149,   149,   149,   150,
     150,   151,   151,   151,   152,   152,   153,   153,   153,   153
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     3,     2,     0,     1,     3,     1,     3,     2,
       3,     3,     7,     5,     7,     9,     5,     2,     3,     2,
       3,     2,     3,     3,     5,     7,     9,    10,     5,     7,
       1,     3,     5,     1,     3,     1,     3,     1,     3,     1,
       1,     3,     1,     3,     0,     9,     9,     2,     3,     4,
       5,     0,     0,     1,     1,     4,     1,     4,     1,     0,
       6,     0,     0,     2,     1,     4,     3,     4,     4,     5,
       0,     4,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     1,     3,     4,     4,     4,     4,     6,
       6,     1,     2,     3,     4,     0,     6,     1,     3,     1,
       4,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     2,     2,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     2,     2,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     5,     2,     2,     2,     2,
       2,     2,     2,     1,     4,     2,     3,     2,     0,     1,
       3,     1,     4,     0,     1,     3,     1,     3,     4,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize;

    /* The state stack.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss;
    yy_state_t *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yynerrs = 0;
  yystate = 0;
  yyerrstatus = 0;

  yystacksize = YYINITDEPTH;
  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;


  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2:
#line 142 "php_parser.y"
                                                         { g_syn_tree_top = (yyvsp[-1].syn_node); }
#line 2236 "php_parser.c"
    break;

  case 3:
#line 146 "php_parser.y"
                                                  { (yyval.syn_node) = add_statement_2_list((yyvsp[-1].syn_node), (yyvsp[0].syn_node)); }
#line 2242 "php_parser.c"
    break;

  case 4:
#line 147 "php_parser.y"
                            { (yyval.syn_node) = 0; }
#line 2248 "php_parser.c"
    break;

  case 6:
#line 153 "php_parser.y"
                                                           { (yyval.syn_node) = (yyvsp[-1].syn_node); }
#line 2254 "php_parser.c"
    break;

  case 8:
#line 159 "php_parser.y"
                                                                                                { (yyval.syn_node) = (yyvsp[-1].syn_node); }
#line 2260 "php_parser.c"
    break;

  case 9:
#line 160 "php_parser.y"
                                                                                                                { (yyval.syn_node) = make_expr_syn_node(PHP_ST_EXPR, (yyvsp[-1].exp_node)); }
#line 2266 "php_parser.c"
    break;

  case 10:
#line 161 "php_parser.y"
                                                                                                { (yyval.syn_node) = 0; }
#line 2272 "php_parser.c"
    break;

  case 11:
#line 162 "php_parser.y"
                                                                                                { (yyval.syn_node) = (yyvsp[-1].syn_node); }
#line 2278 "php_parser.c"
    break;

  case 12:
#line 163 "php_parser.y"
                                                                        { (yyval.syn_node) = make_ifelse_syn_node((yyvsp[-4].exp_node), (yyvsp[-2].syn_node), (yyvsp[-1].syn_node), (yyvsp[0].syn_node)); }
#line 2284 "php_parser.c"
    break;

  case 13:
#line 164 "php_parser.y"
                                                                                        { (yyval.syn_node) = make_while_loop_syn_node((yyvsp[-2].exp_node), (yyvsp[0].syn_node), 1); }
#line 2290 "php_parser.c"
    break;

  case 14:
#line 165 "php_parser.y"
                                                                                        { (yyval.syn_node) = make_while_loop_syn_node((yyvsp[-2].exp_node), (yyvsp[-5].syn_node), 0); }
#line 2296 "php_parser.c"
    break;

  case 15:
#line 166 "php_parser.y"
                                                                             { (yyval.syn_node) = make_for_syn_node((yyvsp[-6].exp_node), (yyvsp[-4].exp_node), (yyvsp[-2].exp_node), (yyvsp[0].syn_node)); }
#line 2302 "php_parser.c"
    break;

  case 16:
#line 167 "php_parser.y"
                                                                                { (yyval.syn_node) = make_switch_syn_node((yyvsp[-2].exp_node), (yyvsp[0].exp_node)); }
#line 2308 "php_parser.c"
    break;

  case 17:
#line 168 "php_parser.y"
                                                                                                        { (yyval.syn_node) = make_expr_syn_node(PHP_ST_CONTINUE, 0); }
#line 2314 "php_parser.c"
    break;

  case 18:
#line 169 "php_parser.y"
                                                                                                        { (yyval.syn_node) = make_expr_syn_node(PHP_ST_CONTINUE, (yyvsp[-1].exp_node)); }
#line 2320 "php_parser.c"
    break;

  case 19:
#line 170 "php_parser.y"
                                                                                                                { (yyval.syn_node) = make_expr_syn_node(PHP_ST_BREAK, 0); }
#line 2326 "php_parser.c"
    break;

  case 20:
#line 171 "php_parser.y"
                                                                                                        { (yyval.syn_node) = make_expr_syn_node(PHP_ST_BREAK, (yyvsp[-1].exp_node)); }
#line 2332 "php_parser.c"
    break;

  case 21:
#line 172 "php_parser.y"
                                                                                                                { (yyval.syn_node) = make_expr_syn_node(PHP_ST_RET, 0); }
#line 2338 "php_parser.c"
    break;

  case 22:
#line 173 "php_parser.y"
                                                                                                        { (yyval.syn_node) = make_expr_syn_node(PHP_ST_RET, (yyvsp[-1].exp_node)); }
#line 2344 "php_parser.c"
    break;

  case 23:
#line 174 "php_parser.y"
                                                                                                { (yyval.syn_node) = make_expr_syn_node(PHP_ST_ECHO, (yyvsp[-1].exp_node)); }
#line 2350 "php_parser.c"
    break;

  case 24:
#line 175 "php_parser.y"
                                                                                        {  }
#line 2356 "php_parser.c"
    break;

  case 25:
#line 176 "php_parser.y"
                                                                        {
				(yyval.syn_node) = make_foreach_loop_syn_node((yyvsp[-4].exp_node), 0, (yyvsp[-2].exp_node), (yyvsp[0].syn_node), 0);
			}
#line 2364 "php_parser.c"
    break;

  case 26:
#line 179 "php_parser.y"
                                                                                        {
				(yyval.syn_node) = make_foreach_loop_syn_node((yyvsp[-6].exp_node), (yyvsp[-4].exp_node), (yyvsp[-2].exp_node), (yyvsp[0].syn_node), 0);
			}
#line 2372 "php_parser.c"
    break;

  case 27:
#line 182 "php_parser.y"
                                                                                            {
				(yyval.syn_node) = make_foreach_loop_syn_node((yyvsp[-7].exp_node), (yyvsp[-5].exp_node), (yyvsp[-2].exp_node), (yyvsp[0].syn_node), 1);
			}
#line 2380 "php_parser.c"
    break;

  case 28:
#line 185 "php_parser.y"
                                                                                        { }
#line 2386 "php_parser.c"
    break;

  case 29:
#line 186 "php_parser.y"
                                                                            { }
#line 2392 "php_parser.c"
    break;

  case 30:
#line 187 "php_parser.y"
                                                                                                                        { (yyval.syn_node) = 0; }
#line 2398 "php_parser.c"
    break;

  case 31:
#line 190 "php_parser.y"
                                                        {  }
#line 2404 "php_parser.c"
    break;

  case 32:
#line 191 "php_parser.y"
                                                        {  }
#line 2410 "php_parser.c"
    break;

  case 33:
#line 194 "php_parser.y"
                                        { (yyval.exp_node) = make_exp_1(PHP_OP_LIST, 0); (yyval.exp_node)->exp_node = (yyvsp[0].exp_node); }
#line 2416 "php_parser.c"
    break;

  case 34:
#line 195 "php_parser.y"
                                        {
				PHP_EXP_NODE *last = (yyvsp[-2].exp_node);
				while ( last->next) last = last->next;
				last->next = make_exp_1(PHP_OP_LIST, 0);
				last->next->exp_node = (yyvsp[0].exp_node);
				(yyval.exp_node) = (yyvsp[-2].exp_node);
			}
#line 2428 "php_parser.c"
    break;

  case 37:
#line 211 "php_parser.y"
                                                        { (yyval.syn_node) = 0; }
#line 2434 "php_parser.c"
    break;

  case 38:
#line 212 "php_parser.y"
                                                {  }
#line 2440 "php_parser.c"
    break;

  case 39:
#line 216 "php_parser.y"
                        {
		const char *varname = get_scope_var_name(g_current_scope, (yyvsp[0].exp_node)->var_si_node->var);
		PHP_SCOPE_ITEM *si = get_scope_item(g_current_scope, varname);
		PHP_SCOPE_ITEM *gsi = get_scope_item(g_global_scope, varname);
		if ( gsi && (gsi->type == PHP_SCOPE_VAR) ) {
			free_var_node(si->var);
			php_exp_tree_free((yyvsp[0].exp_node));
			gsi->var->ref_count++;
			si->var = gsi->var;
		} else {
			php_report_error(PHP_ERROR, "There is no such global var");
		}
	}
#line 2458 "php_parser.c"
    break;

  case 40:
#line 231 "php_parser.y"
                                                        { (yyval.syn_node) = 0; }
#line 2464 "php_parser.c"
    break;

  case 41:
#line 232 "php_parser.y"
                                                {  }
#line 2470 "php_parser.c"
    break;

  case 42:
#line 235 "php_parser.y"
                                                { (yyvsp[0].exp_node)->var_node->flags |= PHP_VARFLAG_STATIC; (yyval.exp_node) = (yyvsp[0].exp_node); }
#line 2476 "php_parser.c"
    break;

  case 43:
#line 236 "php_parser.y"
                                                {
			(yyvsp[-2].exp_node)->var_node->flags |= PHP_VARFLAG_STATIC; (yyval.exp_node) = (yyvsp[-2].exp_node);
			value_value_assign(&(yyvsp[-2].exp_node)->var_node->value, &(yyvsp[0].exp_node)->val_node);
		}
#line 2485 "php_parser.c"
    break;

  case 44:
#line 244 "php_parser.y"
                               {
				switch_push_scope_table(make_scope_table());
			}
#line 2493 "php_parser.c"
    break;

  case 45:
#line 246 "php_parser.y"
                                                                            {
				(yyval.syn_node) = make_func_decl_syn_node((yyvsp[-7].str_val), (yyvsp[-4].exp_node));
				(yyval.syn_node)->func_decl->scope = g_current_scope;
				(yyval.syn_node)->func_decl->is_native = 0;
				(yyval.syn_node)->func_decl->code = (yyvsp[-1].syn_node);
				switch_pop_scope_table(0);
				add_func_2_scope(g_current_scope, (yyval.syn_node));
				(yyval.syn_node) = 0;
			}
#line 2507 "php_parser.c"
    break;

  case 46:
#line 255 "php_parser.y"
                                                                                     {  }
#line 2513 "php_parser.c"
    break;

  case 47:
#line 259 "php_parser.y"
                                                                                        { (yyval.exp_node) = make_func_param(0, (yyvsp[0].exp_node), (yyvsp[-1].str_val), 0); }
#line 2519 "php_parser.c"
    break;

  case 48:
#line 260 "php_parser.y"
                                                                                        { (yyval.exp_node) = make_func_param(0, (yyvsp[0].exp_node), (yyvsp[-2].str_val), 1); }
#line 2525 "php_parser.c"
    break;

  case 49:
#line 261 "php_parser.y"
                                                                        { (yyval.exp_node) = make_func_param((yyvsp[-3].exp_node), (yyvsp[0].exp_node), (yyvsp[-1].str_val), 0); }
#line 2531 "php_parser.c"
    break;

  case 50:
#line 262 "php_parser.y"
                                                                        { (yyval.exp_node) = make_func_param((yyvsp[-4].exp_node), (yyvsp[0].exp_node), (yyvsp[-2].str_val), 1); }
#line 2537 "php_parser.c"
    break;

  case 51:
#line 263 "php_parser.y"
                                                                                                                { (yyval.exp_node) = 0; }
#line 2543 "php_parser.c"
    break;

  case 52:
#line 267 "php_parser.y"
                                { (yyval.str_val)[0] = 0; }
#line 2549 "php_parser.c"
    break;

  case 55:
#line 273 "php_parser.y"
                                                  { (yyval.syn_node) = (yyvsp[-2].syn_node); }
#line 2555 "php_parser.c"
    break;

  case 57:
#line 278 "php_parser.y"
                                                      { (yyval.syn_node) = (yyvsp[-2].syn_node); }
#line 2561 "php_parser.c"
    break;

  case 59:
#line 282 "php_parser.y"
                                                { (yyval.exp_node) = 0; }
#line 2567 "php_parser.c"
    break;

  case 60:
#line 286 "php_parser.y"
                                                          { (yyval.syn_node) = add_branch_2_elseif((yyvsp[-5].syn_node), make_ifelse_syn_node((yyvsp[-2].exp_node), (yyvsp[0].syn_node), 0, 0)); }
#line 2573 "php_parser.c"
    break;

  case 61:
#line 287 "php_parser.y"
                                        { (yyval.syn_node) = 0; }
#line 2579 "php_parser.c"
    break;

  case 62:
#line 291 "php_parser.y"
                            { (yyval.syn_node) = 0; }
#line 2585 "php_parser.c"
    break;

  case 63:
#line 292 "php_parser.y"
                               { (yyval.syn_node) = (yyvsp[0].syn_node); }
#line 2591 "php_parser.c"
    break;

  case 65:
#line 296 "php_parser.y"
                                                    { (yyval.syn_node) = (yyvsp[-2].syn_node); }
#line 2597 "php_parser.c"
    break;

  case 66:
#line 300 "php_parser.y"
                                                                { (yyval.exp_node) = (yyvsp[-1].exp_node); }
#line 2603 "php_parser.c"
    break;

  case 67:
#line 301 "php_parser.y"
                                                        { (yyval.exp_node) = (yyvsp[-1].exp_node); }
#line 2609 "php_parser.c"
    break;

  case 68:
#line 302 "php_parser.y"
                                                        { (yyval.exp_node) = (yyvsp[-2].exp_node); }
#line 2615 "php_parser.c"
    break;

  case 69:
#line 303 "php_parser.y"
                                                { (yyval.exp_node) = (yyvsp[-2].exp_node); }
#line 2621 "php_parser.c"
    break;

  case 70:
#line 307 "php_parser.y"
                                {  (yyval.exp_node) = 0; }
#line 2627 "php_parser.c"
    break;

  case 71:
#line 308 "php_parser.y"
                                                                           {
			(yyvsp[-2].exp_node)->tree_node.syn_right = (yyvsp[0].syn_node);
			if ( (yyvsp[-3].exp_node) ) {
				PHP_EXP_NODE *last = (yyvsp[-3].exp_node);
				while ( last->next) last = last->next;
				last->next = make_exp_1(PHP_OP_LIST, 0);
				last->next->exp_node = (yyvsp[-2].exp_node);
				(yyval.exp_node) = (yyvsp[-3].exp_node);
			} else {
				(yyval.exp_node) = make_exp_1(PHP_OP_LIST, 0);
				(yyval.exp_node)->exp_node = (yyvsp[-2].exp_node);
			}
		}
#line 2645 "php_parser.c"
    break;

  case 72:
#line 323 "php_parser.y"
                                { (yyval.exp_node) = make_exp_2(PHP_OP_LIST, (yyvsp[0].exp_node), 0); }
#line 2651 "php_parser.c"
    break;

  case 73:
#line 324 "php_parser.y"
                                                { (yyval.exp_node) = make_exp_2(PHP_OP_LIST, 0, 0); }
#line 2657 "php_parser.c"
    break;

  case 79:
#line 335 "php_parser.y"
                      { (yyval.exp_node) = make_known_const((yyvsp[0].str_val)); }
#line 2663 "php_parser.c"
    break;

  case 81:
#line 339 "php_parser.y"
                                                                        { (yyval.exp_node) = make_exp_2(PHP_OP_CLASS_DEREF, make_const_exp_str((yyvsp[-2].str_val), 0), make_const_exp_str((yyvsp[0].str_val), 0)); }
#line 2669 "php_parser.c"
    break;

  case 82:
#line 340 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2(PHP_OP_OBJECT_DEREF, (yyvsp[-2].exp_node), make_const_exp_str((yyvsp[0].str_val), 0)); }
#line 2675 "php_parser.c"
    break;

  case 84:
#line 345 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2(PHP_OP_ARRAY_BY_KEY, (yyvsp[-2].exp_node), 0); }
#line 2681 "php_parser.c"
    break;

  case 85:
#line 346 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2(PHP_OP_ARRAY_BY_KEY, (yyvsp[-3].exp_node), (yyvsp[-1].exp_node));}
#line 2687 "php_parser.c"
    break;

  case 86:
#line 347 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2(PHP_OP_ARRAY_BY_KEY, (yyvsp[-3].exp_node), (yyvsp[-1].exp_node));}
#line 2693 "php_parser.c"
    break;

  case 87:
#line 348 "php_parser.y"
                                                                { (yyval.exp_node) = make_exp_1(PHP_OP_VAR_BY_EXP, (yyvsp[-1].exp_node)); }
#line 2699 "php_parser.c"
    break;

  case 88:
#line 352 "php_parser.y"
                                                                                                                { (yyval.exp_node) = make_func_call_exp((yyvsp[-3].str_val), (yyvsp[-1].exp_node)); }
#line 2705 "php_parser.c"
    break;

  case 89:
#line 353 "php_parser.y"
                                                                                        { }
#line 2711 "php_parser.c"
    break;

  case 90:
#line 354 "php_parser.y"
                                                                                { }
#line 2717 "php_parser.c"
    break;

  case 91:
#line 357 "php_parser.y"
                                                                { (yyval.exp_node) = make_func_call_param_list(); func_call_add_expr((yyval.exp_node)->var_node, (yyvsp[0].exp_node), 0); }
#line 2723 "php_parser.c"
    break;

  case 92:
#line 358 "php_parser.y"
                                                                        { (yyval.exp_node) = make_func_call_param_list(); func_call_add_expr((yyval.exp_node)->var_node, (yyvsp[0].exp_node), 1); }
#line 2729 "php_parser.c"
    break;

  case 93:
#line 359 "php_parser.y"
                                                                { (yyval.exp_node) = (yyvsp[-2].exp_node); func_call_add_expr((yyval.exp_node)->var_node, (yyvsp[0].exp_node), 0); }
#line 2735 "php_parser.c"
    break;

  case 94:
#line 360 "php_parser.y"
                                                        { (yyval.exp_node) = (yyvsp[-3].exp_node); func_call_add_expr((yyval.exp_node)->var_node, (yyvsp[0].exp_node), 1); }
#line 2741 "php_parser.c"
    break;

  case 95:
#line 361 "php_parser.y"
                                                                                { (yyval.exp_node) = make_func_call_param_list(); }
#line 2747 "php_parser.c"
    break;

  case 96:
#line 366 "php_parser.y"
                                                      { }
#line 2753 "php_parser.c"
    break;

  case 98:
#line 368 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2(PHP_OP_ASS, (yyvsp[-2].exp_node), (yyvsp[0].exp_node)); }
#line 2759 "php_parser.c"
    break;

  case 99:
#line 369 "php_parser.y"
                                                        { (yyval.exp_node) = (yyvsp[0].exp_node); }
#line 2765 "php_parser.c"
    break;

  case 100:
#line 370 "php_parser.y"
                                                { (yyval.exp_node) = make_exp_2(PHP_MAKE_REF, (yyvsp[-3].exp_node), (yyvsp[0].exp_node)); }
#line 2771 "php_parser.c"
    break;

  case 101:
#line 375 "php_parser.y"
                                                { (yyval.exp_node) = make_exp_2_self(PHP_OP_ASS, (yyvsp[-2].exp_node), make_exp_2(PHP_OP_ADD, (yyvsp[-2].exp_node), (yyvsp[0].exp_node))); }
#line 2777 "php_parser.c"
    break;

  case 102:
#line 376 "php_parser.y"
                                                { (yyval.exp_node) = make_exp_2_self(PHP_OP_ASS, (yyvsp[-2].exp_node), make_exp_2(PHP_OP_SUB, (yyvsp[-2].exp_node), (yyvsp[0].exp_node))); }
#line 2783 "php_parser.c"
    break;

  case 103:
#line 377 "php_parser.y"
                                                { (yyval.exp_node) = make_exp_2_self(PHP_OP_ASS, (yyvsp[-2].exp_node), make_exp_2(PHP_OP_MUL, (yyvsp[-2].exp_node), (yyvsp[0].exp_node))); }
#line 2789 "php_parser.c"
    break;

  case 104:
#line 378 "php_parser.y"
                                                { (yyval.exp_node) = make_exp_2_self(PHP_OP_ASS, (yyvsp[-2].exp_node), make_exp_2(PHP_OP_DIV, (yyvsp[-2].exp_node), (yyvsp[0].exp_node))); }
#line 2795 "php_parser.c"
    break;

  case 105:
#line 379 "php_parser.y"
                                                { (yyval.exp_node) = make_exp_2_self(PHP_OP_ASS, (yyvsp[-2].exp_node), make_exp_2(PHP_OP_CAT, (yyvsp[-2].exp_node), (yyvsp[0].exp_node))); }
#line 2801 "php_parser.c"
    break;

  case 106:
#line 380 "php_parser.y"
                                                { (yyval.exp_node) = make_exp_2_self(PHP_OP_ASS, (yyvsp[-2].exp_node), make_exp_2(PHP_OP_REM, (yyvsp[-2].exp_node), (yyvsp[0].exp_node))); }
#line 2807 "php_parser.c"
    break;

  case 107:
#line 381 "php_parser.y"
                                                { (yyval.exp_node) = make_exp_2_self(PHP_OP_ASS, (yyvsp[-2].exp_node), make_exp_2(PHP_OP_AND, (yyvsp[-2].exp_node), (yyvsp[0].exp_node))); }
#line 2813 "php_parser.c"
    break;

  case 108:
#line 382 "php_parser.y"
                                                { (yyval.exp_node) = make_exp_2_self(PHP_OP_ASS, (yyvsp[-2].exp_node), make_exp_2(PHP_OP_OR, (yyvsp[-2].exp_node), (yyvsp[0].exp_node))); }
#line 2819 "php_parser.c"
    break;

  case 109:
#line 383 "php_parser.y"
                                                { (yyval.exp_node) = make_exp_2_self(PHP_OP_ASS, (yyvsp[-2].exp_node), make_exp_2(PHP_OP_XOR, (yyvsp[-2].exp_node), (yyvsp[0].exp_node))); }
#line 2825 "php_parser.c"
    break;

  case 110:
#line 384 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2_self(PHP_OP_ASS, (yyvsp[-2].exp_node), make_exp_2(PHP_OP_SHL, (yyvsp[-2].exp_node), (yyvsp[0].exp_node))); }
#line 2831 "php_parser.c"
    break;

  case 111:
#line 385 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2_self(PHP_OP_ASS, (yyvsp[-2].exp_node), make_exp_2(PHP_OP_SHR, (yyvsp[-2].exp_node), (yyvsp[0].exp_node))); }
#line 2837 "php_parser.c"
    break;

  case 112:
#line 387 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2_self(PHP_OP_ASS, (yyvsp[-1].exp_node), make_exp_2(PHP_OP_ADD, (yyvsp[-1].exp_node), make_const_exp_dnum(1))); }
#line 2843 "php_parser.c"
    break;

  case 113:
#line 388 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2_self(PHP_OP_ASS, (yyvsp[0].exp_node), make_exp_2(PHP_OP_ADD, (yyvsp[0].exp_node), make_const_exp_dnum(1))); }
#line 2849 "php_parser.c"
    break;

  case 114:
#line 389 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2_self(PHP_OP_ASS, (yyvsp[-1].exp_node), make_exp_2(PHP_OP_SUB, (yyvsp[-1].exp_node), make_const_exp_dnum(1))); }
#line 2855 "php_parser.c"
    break;

  case 115:
#line 390 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2_self(PHP_OP_ASS, (yyvsp[0].exp_node), make_exp_2(PHP_OP_SUB, (yyvsp[0].exp_node), make_const_exp_dnum(1))); }
#line 2861 "php_parser.c"
    break;

  case 116:
#line 392 "php_parser.y"
                                                { (yyval.exp_node) = make_exp_2(PHP_OP_LOG_OR, (yyvsp[-2].exp_node), (yyvsp[0].exp_node)); }
#line 2867 "php_parser.c"
    break;

  case 117:
#line 393 "php_parser.y"
                                                { (yyval.exp_node) = make_exp_2(PHP_OP_LOG_AND, (yyvsp[-2].exp_node), (yyvsp[0].exp_node)); }
#line 2873 "php_parser.c"
    break;

  case 118:
#line 394 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2(PHP_OP_LOG_OR, (yyvsp[-2].exp_node), (yyvsp[0].exp_node)); }
#line 2879 "php_parser.c"
    break;

  case 119:
#line 395 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2(PHP_OP_LOG_AND, (yyvsp[-2].exp_node), (yyvsp[0].exp_node)); }
#line 2885 "php_parser.c"
    break;

  case 120:
#line 396 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2(PHP_OP_LOG_XOR, (yyvsp[-2].exp_node), (yyvsp[0].exp_node)); }
#line 2891 "php_parser.c"
    break;

  case 121:
#line 397 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2(PHP_OP_OR, (yyvsp[-2].exp_node), (yyvsp[0].exp_node)); }
#line 2897 "php_parser.c"
    break;

  case 122:
#line 398 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2(PHP_OP_AND, (yyvsp[-2].exp_node), (yyvsp[0].exp_node)); }
#line 2903 "php_parser.c"
    break;

  case 123:
#line 399 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2(PHP_OP_XOR, (yyvsp[-2].exp_node), (yyvsp[0].exp_node)); }
#line 2909 "php_parser.c"
    break;

  case 124:
#line 400 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2(PHP_OP_CAT, (yyvsp[-2].exp_node), (yyvsp[0].exp_node)); }
#line 2915 "php_parser.c"
    break;

  case 125:
#line 401 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2(PHP_OP_ADD, (yyvsp[-2].exp_node), (yyvsp[0].exp_node)); }
#line 2921 "php_parser.c"
    break;

  case 126:
#line 402 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2(PHP_OP_SUB, (yyvsp[-2].exp_node), (yyvsp[0].exp_node)); }
#line 2927 "php_parser.c"
    break;

  case 127:
#line 403 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2(PHP_OP_MUL, (yyvsp[-2].exp_node), (yyvsp[0].exp_node)); }
#line 2933 "php_parser.c"
    break;

  case 128:
#line 404 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2(PHP_OP_DIV, (yyvsp[-2].exp_node), (yyvsp[0].exp_node)); }
#line 2939 "php_parser.c"
    break;

  case 129:
#line 405 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2(PHP_OP_REM, (yyvsp[-2].exp_node), (yyvsp[0].exp_node)); }
#line 2945 "php_parser.c"
    break;

  case 130:
#line 406 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2(PHP_OP_SHL, (yyvsp[-2].exp_node), (yyvsp[0].exp_node)); }
#line 2951 "php_parser.c"
    break;

  case 131:
#line 407 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2(PHP_OP_SHR, (yyvsp[-2].exp_node), (yyvsp[0].exp_node)); }
#line 2957 "php_parser.c"
    break;

  case 132:
#line 408 "php_parser.y"
                                                                { (yyval.exp_node) = (yyvsp[0].exp_node); }
#line 2963 "php_parser.c"
    break;

  case 133:
#line 409 "php_parser.y"
                                                                { (yyval.exp_node) = make_exp_2(PHP_OP_SUB, make_const_exp_dnum(0), (yyvsp[0].exp_node)); }
#line 2969 "php_parser.c"
    break;

  case 134:
#line 410 "php_parser.y"
                                                                { (yyval.exp_node) = make_exp_1(PHP_OP_LOG_NOT, (yyvsp[0].exp_node)); }
#line 2975 "php_parser.c"
    break;

  case 135:
#line 411 "php_parser.y"
                                                                { (yyval.exp_node) = make_exp_1(PHP_OP_NOT, (yyvsp[0].exp_node)); }
#line 2981 "php_parser.c"
    break;

  case 136:
#line 412 "php_parser.y"
                                                { (yyval.exp_node) = make_exp_2(PHP_OP_SAME, (yyvsp[-2].exp_node), (yyvsp[0].exp_node)); }
#line 2987 "php_parser.c"
    break;

  case 137:
#line 413 "php_parser.y"
                                                { (yyval.exp_node) = make_exp_2(PHP_OP_NOT_SAME, (yyvsp[-2].exp_node), (yyvsp[0].exp_node)); }
#line 2993 "php_parser.c"
    break;

  case 138:
#line 414 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2(PHP_OP_EQ, (yyvsp[-2].exp_node), (yyvsp[0].exp_node)); }
#line 2999 "php_parser.c"
    break;

  case 139:
#line 415 "php_parser.y"
                                                { (yyval.exp_node) = make_exp_2(PHP_OP_NEQ, (yyvsp[-2].exp_node), (yyvsp[0].exp_node)); }
#line 3005 "php_parser.c"
    break;

  case 140:
#line 416 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2(PHP_OP_LWR, (yyvsp[-2].exp_node), (yyvsp[0].exp_node)); }
#line 3011 "php_parser.c"
    break;

  case 141:
#line 417 "php_parser.y"
                                                { (yyval.exp_node) = make_exp_2(PHP_OP_LWR_EQ, (yyvsp[-2].exp_node), (yyvsp[0].exp_node)); }
#line 3017 "php_parser.c"
    break;

  case 142:
#line 418 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2(PHP_OP_GRT, (yyvsp[-2].exp_node), (yyvsp[0].exp_node)); }
#line 3023 "php_parser.c"
    break;

  case 143:
#line 419 "php_parser.y"
                                                { (yyval.exp_node) = make_exp_2(PHP_OP_GRT_EQ, (yyvsp[-2].exp_node), (yyvsp[0].exp_node)); }
#line 3029 "php_parser.c"
    break;

  case 144:
#line 420 "php_parser.y"
                                                        { (yyval.exp_node) = (yyvsp[-1].exp_node); }
#line 3035 "php_parser.c"
    break;

  case 145:
#line 421 "php_parser.y"
                                                { (yyval.exp_node) = make_exp_2(PHP_OP_MUX, (yyvsp[-2].exp_node), (yyvsp[0].exp_node)); (yyval.exp_node)->exp_node = (yyvsp[-4].exp_node); }
#line 3041 "php_parser.c"
    break;

  case 146:
#line 422 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_1(PHP_OP_CAST_INT, (yyvsp[0].exp_node)); }
#line 3047 "php_parser.c"
    break;

  case 147:
#line 423 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_1(PHP_OP_CAST_FLOAT, (yyvsp[0].exp_node)); }
#line 3053 "php_parser.c"
    break;

  case 148:
#line 424 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_1(PHP_OP_CAST_STR, (yyvsp[0].exp_node)); }
#line 3059 "php_parser.c"
    break;

  case 149:
#line 425 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_1(PHP_OP_CAST_BOOL, (yyvsp[0].exp_node)); }
#line 3065 "php_parser.c"
    break;

  case 150:
#line 428 "php_parser.y"
                                {  }
#line 3071 "php_parser.c"
    break;

  case 151:
#line 429 "php_parser.y"
                                {  }
#line 3077 "php_parser.c"
    break;

  case 152:
#line 430 "php_parser.y"
                                                                { (yyval.exp_node) = (yyvsp[0].exp_node); }
#line 3083 "php_parser.c"
    break;

  case 153:
#line 432 "php_parser.y"
                                                                { (yyval.exp_node) = (yyvsp[0].exp_node); }
#line 3089 "php_parser.c"
    break;

  case 154:
#line 433 "php_parser.y"
                                              { (yyval.exp_node) = make_exp_1(PHP_OP_ARRAY, (yyvsp[-1].exp_node)); }
#line 3095 "php_parser.c"
    break;

  case 155:
#line 434 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_1(PHP_OP_PRINT, (yyvsp[0].exp_node)); }
#line 3101 "php_parser.c"
    break;

  case 156:
#line 437 "php_parser.y"
                        { (yyval.exp_node) = (yyvsp[-1].exp_node); }
#line 3107 "php_parser.c"
    break;

  case 157:
#line 438 "php_parser.y"
                                        { (yyval.exp_node) = 0; }
#line 3113 "php_parser.c"
    break;

  case 158:
#line 439 "php_parser.y"
                                        { (yyval.exp_node) = 0; }
#line 3119 "php_parser.c"
    break;

  case 161:
#line 447 "php_parser.y"
                                                { /*$$ = make_assign_node($1);*/ }
#line 3125 "php_parser.c"
    break;

  case 162:
#line 448 "php_parser.y"
                                                { (yyval.exp_node) = (yyvsp[-1].exp_node); }
#line 3131 "php_parser.c"
    break;

  case 163:
#line 449 "php_parser.y"
                                                                        { /*$$ = make_assign_node(0);*/ }
#line 3137 "php_parser.c"
    break;

  case 164:
#line 452 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_1(PHP_OP_LIST, 0); (yyval.exp_node)->exp_node = (yyvsp[0].exp_node); }
#line 3143 "php_parser.c"
    break;

  case 165:
#line 453 "php_parser.y"
                                                {
				PHP_EXP_NODE *last = (yyvsp[-2].exp_node);
				while ( last->next) last = last->next;
				last->next = make_exp_1(PHP_OP_LIST, 0);
				last->next->exp_node = (yyvsp[0].exp_node);
				(yyval.exp_node) = (yyvsp[-2].exp_node);
			}
#line 3155 "php_parser.c"
    break;

  case 166:
#line 462 "php_parser.y"
                                                                { (yyval.exp_node) = make_exp_1(PHP_OP_ARRAY_PAIR, (yyvsp[0].exp_node)); }
#line 3161 "php_parser.c"
    break;

  case 167:
#line 463 "php_parser.y"
                                                        { (yyval.exp_node) = make_exp_2(PHP_OP_ARRAY_PAIR, (yyvsp[-2].exp_node), (yyvsp[0].exp_node)); }
#line 3167 "php_parser.c"
    break;

  case 168:
#line 464 "php_parser.y"
                                                { (yyval.exp_node) = make_exp_2(PHP_OP_ARRAY_REF_PAIR, (yyvsp[-3].exp_node), (yyvsp[0].exp_node)); }
#line 3173 "php_parser.c"
    break;

  case 169:
#line 465 "php_parser.y"
                                                                { (yyval.exp_node) = make_exp_1(PHP_OP_ARRAY_REF_PAIR, (yyvsp[0].exp_node)); }
#line 3179 "php_parser.c"
    break;


#line 3183 "php_parser.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

